<?php

namespace Teknisa\CRM\Factory;

use Doctrine\ORM\EntityManager;

class crm00001000ParametrizacaoCrmFactory {
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function requestGetCrmParametrization($paramsSelectCrmParametrization){
        
        $querySelectCrmParametrization = "SELECT *
                                        FROM CRM_PARAMETRIZACAO
                                        WHERE NRORG = :NRORG";   
                         
        try
        {
            $std = $this->connection->prepare($querySelectCrmParametrization);
            $std->execute($paramsSelectCrmParametrization);
            $crmParametrization = $std->fetchAll();
            
        }catch (\Exception $e)
        {
            throw $e;
        }
        
        return $crmParametrization;
        
    }
    
    public function createMododivulg($params){

        $insert = "INSERT INTO MODODIVULG (CDMODODIVULG, NMMODODIVULG, DTULTATUMDIV, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO,
                               CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO, IDRDSTATION)
                    VALUES (:CDMODODIVULG,
                            :NMMODODIVULG,
                            SYSDATE,
                            :NRORG,
                            SYSDATE,
                            SYSDATE,
                            :NRORG,
                            :CDOPERINCLUSAO,
                            :NRORG,
                            :CDOPERINCLUSAO,
                            'S',
                            'S')";
                 
        try{
            $std = $this->connection->prepare($insert);
            $std->execute($params);
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function getModoDivulgRDStation($nrorg){
        
        $select = "SELECT CDMODODIVULG FROM MODODIVULG WHERE NRORG = $nrorg AND IDRDSTATION = 'S' ";   
                         
        try
        {
            $std = $this->connection->prepare($select);
            $std->execute();
            $mododivulg = $std->fetchAll();
            if(isset($mododivulg[0]))
                return $mododivulg[0];
            else 
                return array();
            
            
        }catch (\Exception $e)
        {
            throw $e;
        }
        
    }
    
}