var ger01901_cadastro_tipo_arvore_produto_controller = function (ScreenService, ProdutoService, General) {

	var G_NRARVPRODPAI;
	var G_NMARVPRODPAI;
	var G_NRTPARVPRODPAI;

	this.novoTipoArvore = function (widget) {
		widget.newRow();
		ScreenService.openSwipe(widget);
	};

	this.onEnterEstrutura = function (widget) {
		if (widget.mode == "list")
			widget.reload();
	};

	this.onEnterTabTipoArvore = function (widget) {
		if (widget.mode == "edit") {
			widget.container.getWidget("estrutura").isVisible = false;
		} else {
			widget.container.getWidget("estrutura").isVisible = true;
		}
	};

	this.desabilitaEHabilitaEstrutura = function (widget, option) {
		General.changeWidgetAcessibility(widget.widgets, option);
	};

	this.onEnterTabEstrutura = function (widget) {

		var nrtparvprod = widget.container.getWidget('tipoarvoreproduto').currentRow.NRTPARVPROD;

		var filter = [
			{
				"name": "NRTPARVPROD",
				"operator": "=",
				"value": nrtparvprod
            }
        ];

		widget.dataSourceFilter = filter;
		widget.getField('NMARVOREPRODPAI').dataSourceFilter = angular.copy(filter);
		
		widget.reload();

	};

	this.getArvProdPai = function (widget) {

		G_NRARVPRODPAI = widget.currentRow.NRARVOREPROD;
		G_NMARVPRODPAI = widget.currentRow.NMARVOREPROD;

	};

	this.novoItemEstrutura = function (widget) {
		var novoNrarvoreprodpai;
		var novoNmarvoreprodpai;
		if (widget.mode === "view") {
			novoNrarvoreprodpai = typeof (widget.currentRow.NRARVOREPROD) !== "undefined" ? widget.currentRow.NRARVOREPROD : null;
			novoNmarvoreprodpai = typeof (widget.currentRow.NMARVOREPROD) !== "undefined" ? widget.currentRow.NMARVOREPROD : null;
		} else {
			novoNrarvoreprodpai = null;
			novoNmarvoreprodpai = null;
		}

		ScreenService.openSwipe(widget).then(function () {
			widget.edit();
			widget.newRow();
			widget.getField('NMARVOREPRODPAI').setValue(novoNmarvoreprodpai);
			widget.currentRow.NRARVOREPRODPAI = novoNrarvoreprodpai;
			widget.currentRow.NRTPARVPRODPAI = widget.currentRow.NRTPARVPROD;
		});

	};

	this.salvarNovoItemEstrutura = function (widget) {

		widget.currentRow.NRTPARVPROD = widget.container.getWidget('tipoarvoreproduto').currentRow.NRTPARVPROD;
		widget.currentRow.NRTPARVPRODPAI = widget.container.getWidget('tipoarvoreproduto').currentRow.NRTPARVPROD;
		widget.currentRow.NRARVOREPRODPAI = !(typeof widget.currentRow.NRARVOREPRODPAI === "undefined" || widget.currentRow.NRARVOREPRODPAI === null) ? widget.currentRow.NRARVOREPRODPAI : null;
		if (!widget.currentRow.__is_new && verificaParentesco(widget)) {
			General.saveCrud(widget).then(function () {
				widget.reload();
			});
		} else if (widget.currentRow.__is_new) {
			General.saveCrud(widget).then(function () {
				widget.reload();
				widget.currentRow = {};
			});
		} else {
			ScreenService.showMessage("O grupo nao pode ser movido para um de seus grupos filhos");
		}

	};

	var verificaParentesco = function (widget) {

		var valido = true;

		if (!widget.currentRow.__is_new) {
			var rows = widget.dataSource.data;
			var nrarvoreprodpai = widget.currentRow.NRARVOREPRODPAI !== "undefined" && widget.currentRow.NRARVOREPRODPAI !== null ? widget.currentRow.NRARVOREPRODPAI.toString() : "";
			var nrarvoreprod = widget.currentRow.NRARVOREPROD.toString();
			rows.forEach(function (row) {
				if (row.NRARVOREPROD === nrarvoreprodpai) {
					if (row.NRARVOREPRODPAI === nrarvoreprod)
						valido = false;
				}
			});
		}

		return valido;

	};

	this.filtroParaNivelPai = function (widget) {

		var field = widget.getField('NMARVOREPRODPAI');
		if (typeof widget.currentRow.NRARVOREPROD !== "undefined") {
			field.dataSourceFilter.push({
				"name": "NRARVOREPROD",
				"operator": "<>",
				"value": widget.currentRow.NRARVOREPROD
			});
		}
		field.reload();
	};

};

Configuration(function (ContextRegister, eventEngine) {
	ContextRegister.register('ger01901_cadastro_tipo_arvore_produto_controller', ger01901_cadastro_tipo_arvore_produto_controller);
});