function InitService(restEngine, templateManager,ZHPromise, ScreenService) {

    //var IDENTITY_URI = "http://crm.pebbian.com/teknisa/";
    var self =this;
    var buildRequestObj = function (baseUrl, service, params) {
        return {
            "service": service,
            "params": params,
            "typeRequest": "post",
            "baseUrl": baseUrl
        };
    };

    this.getCookie = function (cname) {
        var name = cname + "=";
        var ca = document.cookie.split(';');
        for (var i = 0; i < ca.length; i++) {
            var c = ca[i];
            while (c.charAt(0) == ' ') c = c.substring(1);
            if (c.indexOf(name) === 0) return c.substring(name.length, c.length);
        }
        return "";
    };

    this.startSession = function (token) {
        var cookie = window.document.location.href.split('&');
        if(cookie[2])
        {
            cookie = cookie.split('=');
            if(cookie[1])
            {
                cookie = cookie[1];
                cookie = cookie.substr(0, (cookie.length-7));
                /*var cookie = this.getCookie('varwwwv_250CRM');
                var cookie = this.getCookie('Cworkfoldercrm');*/

                var requestObj = buildRequestObj(window.serviceUrl, "/startSession", {
                    "row": {"TOKEN": cookie},
                    "requestType": "Row"
                });

                var location = window.document.location.href.split('&');
                if(location[1])
                {
                    location = location[1].split('=');
                    if(location[1])
                    {
                        location = location[1];
                        var widget = templateManager.container.getActiveWidget();
                        return restEngine.post(requestObj).then(function (data) {
                            widget.currentRow.CDOPERADOR = data.dataset.operador.email;
                            widget.currentRow.CDSENHAOPER = data.dataset.operador.senha;
                             var promises = [self.autenticar(widget)];
                             ZHPromise.all(promises).then(function() {
                             ScreenService.openWindow(location).then(function(){
                             templateManager.container.showMenu = false;
                             });
                             if (data.method[0].parameters[1] !== false) {
                                setLocalVar("CDOPERADOR", data.method[0].parameters[1]);
                                setLocalVar("NRORG", data.method[1].parameters[1]);
                             }
                             });
                        }, function(callback) {
                         if (callback.data) {
                             ScreenService.showMessage(ScreenService.i18n(callback.data.error));
                             } else {
                             ScreenService.showMessage(ScreenService.i18n('Timeout! Verifique sua conexão e tente novamente!'), 'error');
                             }
                         });
                    }
                }
            }
        }

    };

    this.getRules = function(groupIds) {
        return restEngine.post('/zhu_acl_element_login',
            {
                "requestType": "FilterData",
                "filter": [
                    {
                        "name": "GROUP_ID",
                        "operator": "=",
                        "value": groupIds
                    }
                ]
            }
        );
    };

    this.autenticar = function(widget){

        var user = widget.currentRow.CDOPERADOR;
        var password = widget.currentRow.CDSENHAOPER;

        var filters = [{
            "name": "user",
            "value": user,
            "operator": "="
        }, {
            "name": "password",
            "value": password,
            "operator": "="
        }];

        localStorageEngine.download('/login/login', filters).then(function(data){
            var userId = data.login;
            templateManager.userId = userId;
            var accessProfiles = getLocalVar('NRGROUPCTLACESS');
            localStorageEngine.setLocalVar('login', user);
            localStorageEngine.setLocalVar('PROJECT_ID', 13);
            self.getRules(accessProfiles).then( //remove the hash when query is ready
                function(response) {
                    var data = response.dataset.zhu_access_control_rule_login;
                    var rules = {};
                    data.forEach(
                        function(rule) {
                            var profileObject = {
                                'rule': rule.RULE
                            };
                            var profileObjects = {};
                            profileObjects[userId] = profileObject;
                            rules[rule.NAME] = {
                                'itemName': rule.NAME,
                                'userGroups': profileObjects
                            };
                        }
                    );
                    templateManager.aclRules = rules;
                }
            );


            ScreenService.buildUserData(data.userData.nmoperador, [data.userData.nmEstrutLegalOper,""],function(){
                ScreenService.successNotification("Logado com sucesso!");
            });
        });
    };
}
Configuration(function(ContextRegister){
    ContextRegister.register('InitService', InitService);
});