function crm00004000_IndicadorLead_Controller(ScreenService,ZHPromise,templateManager,localStorageEngine) {

    this.exibeValoresLeadOperMensal = function(){
        var widget = templateManager.container.getActiveWidget();

        ScreenService.confirmMessage("Período selecionado: "+widget.currentRow.DTLABEL+"<br>Quantidade de leads convertidos: "+
                                      widget.currentRow.QTDECAND+"<br><br>Visualizar a quantidade de conversões por operador no período selecionado?",'information',function(){
        var operWidget = templateManager.container.getWidget('operador_dados');

            operWidget.dataSourceFilter = [{"name":"DTINCLUSAO", "operator":"=", "value":widget.currentRow.DTLABEL}];
            ScreenService.openWidgetAsGadget(operWidget,"swipe");
            operWidget.reload();
        },function(){

        });
    };

    this.exibeValoresOperPeriodo = function(){
        var widget = templateManager.container.getActiveWidget();
        ScreenService.showMessage("Nome do Operador: "+widget.currentRow.NMOPERADOR+"<br>Quantidade de leads convertidos: "+
                                  widget.currentRow.QTDECAND,'sucess','information');
    };

    this.filterManager = function(widget) {
        var parent = widget.parentWidget;
        FilterService.parentFilter(parent, widget).then(function(){
            ScreenService.closePopup();
            parent.activate();
        });
    };

    this.closePopUpFilter = function(widget){
        var parent = widget.parentWidget;
        ScreenService.closePopup();
        parent.activate();
    };

    this.getPopUpGeralFilter = function(){
        return templateManager.container.getWidget(templateManager.container.getActiveWidget().widgets[0].name);
    };

    this.openPopUpGeralFilter = function(){
        var currentWidget = templateManager.container.getActiveWidget();
        this.getPopUpGeralFilter().parentWidget = currentWidget;
        ScreenService.openPopup(this.getPopUpGeralFilter());
    };

}

Configuration(function (ContextRegister) {
    ContextRegister.register("crm00004000_IndicadorLead_Controller", crm00004000_IndicadorLead_Controller);
});
